#!/usr/bin/env node

process.on("unhandledRejection", err => {
	console.error("Unhandled rejection");
	console.trace(err);
	process.exit(1);
});

var dns = require("dns");
var StratumClient = require("./js/stratum-client");
var CPUMiner = require("./js/miner-cpu");
var ASICMiner = require("./js/miner-asic");

var domain = "stratum.slushpool.com"
var port = 3333;

async function main() {
	dns.lookup(domain, async (err, ip) => {
		if (err) throw err;

		var m = new CPUMiner();
		var c = new StratumClient(ip, port, m);
		try {
			await c.connect();
			await c.auth("mort96.worker1", "test");
		} catch (err) {
			console.log(err);
			process.exit(1);
		}
	});
}
main();
